//+------------------------------------------------------------------+
//|                                               EasyTradePanel.mqh |
//|                                          Copyright 2015, semtiko |
//|                            https://www.mql5.com/ru/users/semtiko |
//|                                                                  |
//|                                                                  |
//| Sorry for ugly code style - it is rules of MetaQuotes            |
//+------------------------------------------------------------------+
#include <Controls\Dialog.mqh>
#include <Controls\Label.mqh>
#include <Controls\Edit.mqh>
#include <Controls\Button.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum PANEL_MODE 
  {
   PIPS,// 
   PERCENTS // 
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum PRICE_MODE 
  {
   DEPOSIT,//  
   VOLUMES //   
  };

//----------- Input parameters

input PANEL_MODE volumesMode=PIPS; // 
input PRICE_MODE priceMode=VOLUMES; //  / ( "" = "")

input int defaultVolume=0; //   . $, % -   .  

input int defaultBuyTp = 0; // Buy TakeProfit  
input int defaultBuySl = 0; // Buy StopLoss  

input int defaultSellTp = 0; // Sell TakeProfit  
input int defaultSellSl = 0; // Sell StopLoss  
//----------------------------

class CPanelDialog : public CAppDialog
  {
public:
   virtual bool      Create(const long chart,const string name,const int subwin,const int x,const int y,const int width,const int height);
   virtual bool      OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam);
   virtual void      update(void);

   CLabel            m_betLabel,m_pipsLabel,m_resultLabel,m_slippageLabel;
   CEdit             m_slippageEdit;

   CLabel            m_buyTpLabel,m_buySlLabel;
   CLabel            m_sellTpLabel,m_sellSlLabel;

   CEdit             m_buyDollarsEdit,m_buyTpPipsEdit,m_buyTpDollarsEdit;
   CEdit             m_buyLotsEdit,m_buySlPipsEdit,m_buySlDollarsEdit;

   CEdit             m_sellLotsEdit,m_sellSlPipsEdit,m_sellSlDollarsEdit;
   CEdit             m_sellDollarsEdit,m_sellTpPipsEdit,m_sellTpDollarsEdit;

   CButton           m_buyButton,m_sellButton;

   double            m_buyDollars,m_buyLots,m_buyTpPips,m_buySlPips,m_buyTpPrice,m_buySlPrice;
   double            m_sellDollars,m_sellLots,m_sellTpPips,m_sellSlPips,m_sellTpPrice,m_sellSlPrice;

   int               m_slippage;
   double            m_pointPrice,m_lotSize;
   bool              m_pareRight,m_pareReverse,m_pareCross,m_pareFutures;
   string            m_pareFirstName,m_pareSecondName;
   double            m_ask,m_bid;
   double            m_lotPrice,m_tempBuyVolume,m_tempSellVolume;

protected:
   void              setPrices(void);
   void              resetToDefault(void);
   void              ChangeVolumes(void);

   void              OnSymbolChange(void);
   void              OnEditChange(void);

   void              Buy(void);
   void              Sell(void);

   void              CreateLabel(CLabel &label,string name,int x,int y,string str);
   void              CreateEdit(CEdit &edit,string name,int x,int y,int width,int height,int clr);
   void              CreateButton(CButton &button,string name,int x,int y,int width,int height,string str);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
EVENT_MAP_BEGIN(CPanelDialog)
ON_EVENT(ON_CLICK,m_buyButton,Buy)
ON_EVENT(ON_CLICK,m_sellButton,Sell)

ON_EVENT(ON_END_EDIT,m_buyTpPipsEdit,setPrices)
ON_EVENT(ON_END_EDIT,m_buySlPipsEdit,setPrices)
ON_EVENT(ON_END_EDIT,m_sellTpPipsEdit,setPrices)
ON_EVENT(ON_END_EDIT,m_sellSlPipsEdit,setPrices)

ON_EVENT(ON_END_EDIT,m_buyDollarsEdit,ChangeVolumes)
ON_EVENT(ON_END_EDIT,m_sellDollarsEdit,ChangeVolumes)
EVENT_MAP_END(CAppDialog)

bool CPanelDialog::Create(const long chart,const string name,const int subwin,const int x,const int y,const int width,const int height)
  {
   if(StringLen(Symbol())<6 || StringFind(Symbol(),"#")>-1 || StringFind(Symbol(),"_")>-1) // No indicatives and futures
      return false;

   if(!CAppDialog::Create(chart,name,subwin,x,y,width,height))
      return false;

   int col1 = 5;
   int col2 = 75;
   int col3 = 120;
   int col4 = 187;
   int col5 = 254;

   int row1 = 5;
   int row2 = 28;
   int row3 = 52;
   int row4 = 77;
   int row5 = 102;

   int editWidth=63;
   int editHeight=20;

   if(volumesMode==PIPS) 
     {
      CreateLabel(m_betLabel,"m_betLabel",col1+5,row1,"Volume $");
      CreateLabel(m_pipsLabel,"m_pipsLabel",col3+20,row1,"Pips");
        } else if(volumesMode==PERCENTS) {
      CreateLabel(m_betLabel,"m_betLabel",col1+5,row1,"Volume %");

      if(priceMode==DEPOSIT) 
        {
         CreateLabel(m_pipsLabel,"m_pipsLabel",col3+10,row1,"% Depo");
           } else if(priceMode==VOLUMES) {
         CreateLabel(m_pipsLabel,"m_pipsLabel",col3-1,row1,"% (Volume)");
        }
     }

   CreateLabel(m_resultLabel,"m_resultLabel",col4+7,row1,"Result $");

   CreateLabel(m_slippageLabel,"m_slippageLabel",col5+2,row1,"Slip");
   CreateEdit(m_slippageEdit,"m_slippageEdit",col5+29,row1,editWidth/2+2,editHeight,clrWhite);
   m_slippageEdit.TextAlign(ALIGN_CENTER);

   CreateEdit(m_buyDollarsEdit,"m_buyDollarsEdit",col1,row2,editWidth,editHeight,clrWhite);
   m_buyDollarsEdit.TextAlign(ALIGN_CENTER);

   CreateEdit(m_buyLotsEdit,"m_buyLotsEdit",col1,row3,editWidth,editHeight,clrGainsboro);
   m_buyLotsEdit.TextAlign(ALIGN_CENTER);
   m_buyLotsEdit.ReadOnly(true);

   CreateEdit(m_sellLotsEdit,"m_sellLotsEdit",col1,row4,editWidth,editHeight,clrGainsboro);
   m_sellLotsEdit.TextAlign(ALIGN_CENTER);
   m_sellLotsEdit.ReadOnly(true);

   CreateEdit(m_sellDollarsEdit,"m_sellDollarsEdit",col1,row5,editWidth,editHeight,clrWhite);
   m_sellDollarsEdit.TextAlign(ALIGN_CENTER);

   CreateLabel(m_buyTpLabel,"m_buyTpLabel",col2,row2,"Buy TP");
   CreateLabel(m_buySlLabel,"m_buySlLabel",col2,row3,"Buy SL");
   CreateLabel(m_sellSlLabel,"m_sellSlLabel",col2,row4,"Sell SL");
   CreateLabel(m_sellTpLabel,"m_sellTpLabel",col2,row5,"Sell TP");

   CreateEdit(m_buyTpPipsEdit,"m_buyTpPipsEdit",col3,row2,editWidth,editHeight,clrGreenYellow);
   m_buyTpPipsEdit.TextAlign(ALIGN_CENTER);

   CreateEdit(m_buySlPipsEdit,"m_buySlPipsEdit",col3,row3,editWidth,editHeight,clrRed);
   m_buySlPipsEdit.TextAlign(ALIGN_CENTER);

   CreateEdit(m_sellSlPipsEdit,"m_sellSlPipsEdit",col3,row4,editWidth,editHeight,clrRed);
   m_sellSlPipsEdit.TextAlign(ALIGN_CENTER);

   CreateEdit(m_sellTpPipsEdit,"m_sellTpPipsEdit",col3,row5,editWidth,editHeight,clrGreenYellow);
   m_sellTpPipsEdit.TextAlign(ALIGN_CENTER);

   CreateEdit(m_buyTpDollarsEdit,"m_buyTpDollarsEdit",col4,row2,editWidth,editHeight,clrGainsboro);
   m_buyTpDollarsEdit.TextAlign(ALIGN_CENTER);
   m_buyTpDollarsEdit.ReadOnly(true);

   CreateEdit(m_buySlDollarsEdit,"m_buySlDollarsEdit",col4,row3,editWidth,editHeight,clrGainsboro);
   m_buySlDollarsEdit.TextAlign(ALIGN_CENTER);
   m_buySlDollarsEdit.ReadOnly(true);

   CreateEdit(m_sellSlDollarsEdit,"m_sellSlDollarsEdit",col4,row4,editWidth,editHeight,clrGainsboro);
   m_sellSlDollarsEdit.TextAlign(ALIGN_CENTER);
   m_sellSlDollarsEdit.ReadOnly(true);

   CreateEdit(m_sellTpDollarsEdit,"m_sellTpDollarsEdit",col4,row5,editWidth,editHeight,clrGainsboro);
   m_sellTpDollarsEdit.TextAlign(ALIGN_CENTER);
   m_sellTpDollarsEdit.ReadOnly(true);

   CreateButton(m_buyButton,"m_buyButton",col5,row2,editWidth,editHeight*2+5,"BUY");
   ObjectSetInteger(0,"m_buyButton",OBJPROP_BGCOLOR,clrMediumBlue);
   ObjectSetInteger(0,"m_buyButton",OBJPROP_COLOR,clrWhite);
   ObjectSetString(0,"m_buyButton",OBJPROP_FONT,"Arial");
   ObjectSetInteger(0,"m_buyButton",OBJPROP_FONTSIZE,14);

   CreateButton(m_sellButton,"m_sellButton",col5,row4,editWidth,editHeight*2+5,"SELL");
   ObjectSetInteger(0,"m_sellButton",OBJPROP_BGCOLOR,clrCrimson);
   ObjectSetInteger(0,"m_sellButton",OBJPROP_COLOR,clrWhite);
   ObjectSetString(0,"m_sellButton",OBJPROP_FONT,"Arial");
   ObjectSetInteger(0,"m_sellButton",OBJPROP_FONTSIZE,14);

   resetToDefault();

     { // Load parameters
      if(defaultVolume>0) 
        {
         m_buyDollarsEdit.Text((string) defaultVolume);
         m_sellDollarsEdit.Text((string) defaultVolume);
        }

      if(defaultBuyTp>0)
         m_buyTpPipsEdit.Text((string) defaultBuyTp);

      if(defaultBuySl>0)
         m_buySlPipsEdit.Text((string) defaultBuySl);

      if(defaultSellTp>0)
         m_sellTpPipsEdit.Text((string) defaultSellTp);

      if(defaultSellSl>0)
         m_sellSlPipsEdit.Text((string) defaultSellSl);

      ChangeVolumes();
     }

   return true;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::update(void)
  {
   setPrices();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::setPrices(void)
  {
     { // Please, don't move it to constructor. It's not hard for processor, but good to resolve some rare bug.
      m_lotSize=MarketInfo(Symbol(),MODE_LOTSIZE);
      m_pareFirstName=StringSubstr(Symbol(),0,3);
      m_pareSecondName=StringSubstr(Symbol(),3,6);

      if(m_pareFirstName=="USD") 
        {
         m_pareReverse=true;
         m_lotPrice=(m_lotSize/AccountLeverage())*0.01;
           } else if(m_pareSecondName=="USD") {
         m_pareRight= true;
         m_lotPrice =((m_lotSize/AccountLeverage()) *(Ask -(Ask-Bid))) * 0.01;
           } else {
         m_pareCross=true;
         m_ask=MarketInfo(m_pareFirstName+"USD",MODE_ASK);

         if(m_ask == 0)
            m_ask = MarketInfo("USD" + m_pareFirstName, MODE_ASK);

         m_bid=MarketInfo(m_pareFirstName+"USD",MODE_BID);

         if(m_bid == 0)
            m_bid = MarketInfo("USD" + m_pareFirstName, MODE_BID);

         m_lotPrice=((m_lotSize/AccountLeverage())*m_ask)*0.01;
        }
     }

     { // Buy section
      m_tempBuyVolume=m_buyDollars;

      if(volumesMode==PERCENTS)
         m_tempBuyVolume=(AccountBalance() *(m_buyDollars/100));

      if(m_pareReverse) 
        {
         m_buyLots=m_tempBuyVolume/(m_lotSize/AccountLeverage());
           } else if(m_pareRight) {
         m_buyLots=m_tempBuyVolume/((m_lotSize/AccountLeverage())*Ask);
           } else { // m_pareCross
         m_buyLots=m_tempBuyVolume/((m_lotSize/AccountLeverage())*m_ask);
        }

      m_buyLots=NormalizeDouble(m_buyLots,2);
      m_buyLotsEdit.Text(DoubleToStr(m_buyLots,2));

      if(m_pareReverse) 
        {
         m_pointPrice=((m_lotSize*Point)*m_buyLots)/Bid;
           } else if(m_pareRight) {
         m_pointPrice=(m_lotSize*Point)*m_buyLots;
           } else { // m_pareCross
         m_pointPrice=(m_lotSize*m_buyLots*m_ask*Point)/Ask;
        }

      if(m_buyTpPipsEdit.Text()=="")
         m_buyTpPipsEdit.Text("0");

      m_buyTpPips=StringToDouble(m_buyTpPipsEdit.Text());

      if(m_buyTpPips<0) 
        {
         m_buyTpPips=0;
         m_buyTpPipsEdit.Text("0");
        }

      m_buySlPips=StringToDouble(m_buySlPipsEdit.Text());

      if(m_buySlPips<0) 
        {
         m_buySlPips=0;
         m_buySlPipsEdit.Text("0");
        }

      if(m_pointPrice>0) 
        {
         if(volumesMode==PIPS) 
           {
            m_buyTpDollarsEdit.Text(DoubleToString(m_buyTpPips * m_pointPrice, 2));
            m_buySlDollarsEdit.Text(DoubleToString(m_buySlPips * m_pointPrice, 2));
              } else if(volumesMode==PERCENTS) { // Now all "pips" vars is % vars. No need to create new
            if(priceMode==DEPOSIT) 
              {
               m_buyTpDollarsEdit.Text(DoubleToString((AccountBalance() *(m_buyTpPips/100)),2));
               m_buyTpPips=(AccountBalance() *(m_buyTpPips/100))/m_pointPrice;

               m_buySlDollarsEdit.Text(DoubleToString((AccountBalance() *(m_buySlPips/100)),2));
               m_buySlPips=(AccountBalance() *(m_buySlPips/100))/m_pointPrice;
                 } else if(priceMode==VOLUMES) {
               m_buyTpDollarsEdit.Text(DoubleToString((m_tempBuyVolume *(m_buyTpPips/100)),2));
               m_buyTpPips=(m_tempBuyVolume *(m_buyTpPips/100))/m_pointPrice;

               m_buySlDollarsEdit.Text(DoubleToString((m_tempBuyVolume *(m_buySlPips/100)),2));
               m_buySlPips=(m_tempBuyVolume *(m_buySlPips/100))/m_pointPrice;
              }
           }

         m_buyTpPrice = (m_buyTpPips > 0) ? normalize(Ask + normalizePips(m_buyTpPips)) : 0;
         m_buySlPrice = (m_buySlPips > 0) ? normalize(Ask - normalizePips(m_buySlPips)) : 0;
           } else {
         m_buyTpDollarsEdit.Text("0");
         m_buySlDollarsEdit.Text("0");
        }
     }

     { // Sell section
      m_tempSellVolume=m_sellDollars;

      if(volumesMode==PERCENTS)
         m_tempSellVolume=(AccountBalance() *(m_sellDollars/100));

      if(m_pareReverse) 
        {
         m_sellLots=m_tempSellVolume/(m_lotSize/AccountLeverage());
           } else if(m_pareRight) {
         m_sellLots=m_tempSellVolume/((m_lotSize/AccountLeverage())*Bid);
           } else { // m_pareCross
         m_sellLots=m_tempSellVolume/((m_lotSize/AccountLeverage())*m_bid);
        }

      m_sellLots=NormalizeDouble(m_sellLots,2);
      m_sellLotsEdit.Text(DoubleToStr(m_sellLots,2));

      if(m_pareReverse) 
        {
         m_pointPrice=((m_lotSize*Point)*m_sellLots)/Ask;
           } else if(m_pareRight) {
         m_pointPrice=(m_lotSize*Point)*m_sellLots;
           } else { // m_pareCross
         m_pointPrice=(m_lotSize*m_sellLots*m_bid*Point)/Bid;
        }

      m_sellTpPips=StringToDouble(m_sellTpPipsEdit.Text());

      if(m_sellTpPips<0) 
        {
         m_sellTpPips=0;
         m_sellTpPipsEdit.Text("0");
        }

      m_sellSlPips=StringToDouble(m_sellSlPipsEdit.Text());

      if(m_sellSlPips<0) 
        {
         m_sellSlPips=0;
         m_sellSlPipsEdit.Text("0");
        }

      if(m_pointPrice>0) 
        {
         if(volumesMode==PIPS) 
           {
            m_sellTpDollarsEdit.Text(DoubleToString(m_sellTpPips * m_pointPrice, 2));
            m_sellSlDollarsEdit.Text(DoubleToString(m_sellSlPips * m_pointPrice, 2));
              } else if(volumesMode==PERCENTS) { // Now all "pips" vars is % vars. No need to create new
            if(priceMode==DEPOSIT) 
              {
               m_sellTpDollarsEdit.Text(DoubleToString((AccountBalance() *(m_sellTpPips/100)),2));
               m_sellTpPips=(AccountBalance() *(m_sellTpPips/100))/m_pointPrice;

               m_sellSlDollarsEdit.Text(DoubleToString((AccountBalance() *(m_sellSlPips/100)),2));
               m_sellSlPips=(AccountBalance() *(m_sellSlPips/100))/m_pointPrice;
                 } else if(priceMode==VOLUMES) {
               m_sellTpDollarsEdit.Text(DoubleToString((m_tempSellVolume *(m_sellTpPips/100)),2));
               m_sellTpPips=(m_tempSellVolume *(m_sellTpPips/100))/m_pointPrice;

               m_sellSlDollarsEdit.Text(DoubleToString((m_tempSellVolume *(m_sellSlPips/100)),2));
               m_sellSlPips=(m_tempSellVolume *(m_sellSlPips/100))/m_pointPrice;
              }
           }

         m_sellTpPrice = (m_sellTpPips > 0) ? normalize(Bid - normalizePips(m_sellTpPips)) : 0;
         m_sellSlPrice = (m_sellSlPips > 0) ? normalize(Bid + normalizePips(m_sellSlPips)) : 0;
           } else {
         m_sellTpDollarsEdit.Text("0");
         m_sellSlDollarsEdit.Text("0");
        }
     }

   Caption("EasyTrade. Spread: "+IntegerToString((int) MarketInfo(Symbol(),MODE_SPREAD))+" | 0.01 lots = "+DoubleToString(m_lotPrice,2)+" $");
   BringToTop();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::resetToDefault(void)
  {
   m_pareRight= m_pareReverse = m_pareCross = m_pareFutures = false;
   m_buyDollars = m_buyTpPips = m_buyTpPrice = m_buySlPips = m_buySlPrice = 0;
   m_sellDollars= m_buyTpPips = m_buyTpPrice = m_buySlPips = m_buySlPrice = 0;

   m_slippageEdit.Text("15");

   m_buyDollarsEdit.Text("0");
   m_buyTpPipsEdit.Text("0");
   m_buySlPipsEdit.Text("0");
   m_buyTpDollarsEdit.Text("0");
   m_buySlDollarsEdit.Text("0");

   m_sellDollarsEdit.Text("0");
   m_sellTpPipsEdit.Text("0");
   m_sellSlPipsEdit.Text("0");
   m_sellTpDollarsEdit.Text("0");
   m_sellSlDollarsEdit.Text("0");

   ChangeVolumes();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::ChangeVolumes(void)
  {
   bool act=false;

   if(volumesMode==PIPS) 
     {
      m_buyDollars=(int) StringToDouble(m_buyDollarsEdit.Text());
      m_sellDollars=(int) StringToDouble(m_sellDollarsEdit.Text());

      if(m_buyDollars<0) 
        {
         m_buyDollars=0;
         act=true;
           } else if(m_sellDollars<0) {
         m_sellDollars=0;
         act=true;
        }

      if(act) 
        {
         m_buyDollarsEdit.Text((string) m_buyDollars);
         m_sellDollarsEdit.Text((string) m_sellDollars);
        }
        } else if(volumesMode==PERCENTS) {
      m_buyDollars=StringToDouble(m_buyDollarsEdit.Text());
      m_sellDollars=StringToDouble(m_sellDollarsEdit.Text());

      if(m_buyDollars>95) 
        {
         m_buyDollars=95;
         act=true;
           } else if(m_buyDollars<0) {
         m_buyDollars=0;
         act=true;
        }

      if(m_sellDollars>95) 
        {
         m_sellDollars=95;
         act=true;
           } else if(m_sellDollars<0) {
         m_sellDollars=0;
         act=true;
        }

      if(act) 
        {
         m_buyDollarsEdit.Text(DoubleToString(m_buyDollars,1));
         m_sellDollarsEdit.Text(DoubleToString(m_sellDollars,1));
        }
     }

   setPrices();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::Buy(void)
  {
   if(m_buyLots>0)
     {
      setPrices();

      if(OrderSend(Symbol(),OP_BUY,m_buyLots,Ask,m_slippage,m_buySlPrice,m_buyTpPrice)<0)
        {
         PrintFormat("BUY error: %i",GetLastError());
           } else {
         PrintFormat("BUY. Ask: %g, TP: %g, SL: %g",Ask,m_buyTpPrice,m_buySlPrice);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::Sell(void)
  {
   if(m_sellLots>0)
     {
      setPrices();

      if(OrderSend(Symbol(),OP_SELL,m_sellLots,Bid,m_slippage,m_sellSlPrice,m_sellTpPrice)<0)
        {
         PrintFormat("SELL error: %i",GetLastError());
           } else {
         PrintFormat("BUY. Bid: %g, TP: %g, SL: %g",Bid,m_sellTpPrice,m_sellSlPrice);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::CreateLabel(CLabel &label,string name,int x,int y,string str)
  {
   label.Create(m_chart_id, name, m_subwin, x, y, 0, 0);
   label.FontSize(10);
   label.Text(str);
   Add(label);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::CreateEdit(CEdit &edit,string name,int x,int y,int width,int height,int clr)
  {
   edit.Create(m_chart_id, name, m_subwin, x, y, x + width, y + height);
   edit.FontSize(10);
   edit.Color(clrBlack);
   edit.ColorBackground(clr);
   Add(edit);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CPanelDialog::CreateButton(CButton &button,string name,int x,int y,int width,int height,string str)
  {
   button.Create(m_chart_id, name, m_subwin, x, y, x + width, y + height);
   button.Text(str);
   button.FontSize(12);
   Add(button);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double normalize(double value)
  {
   return NormalizeDouble(value, Digits);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double normalizePips(double value)
  {
   return NormalizeDouble(value * Point, Digits);
  }
//+------------------------------------------------------------------+
